--[[
Name: targetAssist
Author: Sonora (The Dragonflight, US Kirin Tor)
Website & SVN: http://wow.curseforge.com/addons/targetassist/
License: GNU General Public License v3
]]

--Runs in application namespace
setfenv(1, targetAssist)

--Starting in version 1.3 the configuration database is versioned to allow automated migration
currentDBVersion = 2

--This table should be serializable
defaultConfig = {
    
    --Header frame configuration
    --headerWidth = 200, DEPRECATED in db 2.0
    headerHeight = 15,
    headerAnchor = {'CENTER', 0, 0},
    headerTexture = [=[Interface\Addons\targetAssist\media\barTex]=],
    headerColor = {0.24, 0.24, 0.24, 1.0},
    headerBackdrop = {
       bgFile = [=[Interface\Tooltips\UI-Tooltip-Background]=],
       insets = {top = -1, left = -1, bottom = -1, right = -1}
    },
    headerUnlocked = true,
    hideOutOfGroup = true,
    hideAddonName = false,
    
    --Target button configuration
    targetHeight = 25,
    targetWidth = 100, --NEW in db 2.0
    targetTexture = [=[Interface\Addons\targetAssist\media\barTex]=],
    targetBackdrop = {
       bgFile = [=[Interface\Tooltips\UI-Tooltip-Background]=],
       insets = {top = -1, left = -1, bottom = -1, right = -1}
    },
    targetBackdropColor = {0.15, 0.15, 0.15},
    
    colorFriendlyTargetsByClass = false,
    friendlyTargetColor = {0.44, 0.37, 0.62, 0.9},
    colorHostileTargetsByClass = false,
    hostileTargetColor = {0.62, 0.27, 0.34, 0.9},
    missingColor = {0.1,0.1,0.1,0},
    myTargetColor = {0.35,0.70,0.42,0.9},
    
    targetButtonAnchor = {'TOPLEFT','BOTTOMLEFT',-2}, --{buttonAnchorPoint, headerAnchorPoint, verticalOffset} (headerAnchorPoint may be point on previous button)
    
    showHealth = true,
    showFriendlyHealthPercent = false,
    showHostileHealthPercent = false,
    
    --Applies to all text
    fontName = "Fonts\\FRIZQT__.TTF",
    fontHeight = 11,
    fontColor = {1,1,1},
    
    --Distance between assist target and assist target target frames
    spacingOffset = 1,
    
    --Features
    autoAcceptBroadcasts = false,
    autoUpdateTanks = true,
    autoUpdateMainAssists = true,
    autoUpdateORA2 = true,
    autoUpdateORA3 = true,
    purgeAutoAdds = true,
    
    showTargetTarget = false,
    showPets = true,
    
    trackNumberTargetingHostiles = true,
    markMostTargetedHostile = true,
    
    trackNumberTargetingFriendlies = true,
    markMostTargetedFriendly = true,
    
    fadeOutOfRange = true,
    outOfRangeAlphaOffset = 0.5,
    
    includePlayer = false,
    invertTargetOrder = false,
    
    --Processing and efficiency
    updateInterval = 0.1,
    broadcastHistory = 10,
    userDisabled = false,
    
    disableClique = false,
    
    --We persist targets between UI loads
    targets = {},

    --Will these ever change?  Here just in case.
    raidIcons = {  --{{Name, texturePath},}
        {'Star',[[Interface\TargetingFrame\UI-RaidTargetingIcon_1]]},
        {'Circle',[[Interface\TargetingFrame\UI-RaidTargetingIcon_2]]},
        {'Diamond',[[Interface\TargetingFrame\UI-RaidTargetingIcon_3]]},
        {'Triangle',[[Interface\TargetingFrame\UI-RaidTargetingIcon_4]]},
        {'Moon',[[Interface\TargetingFrame\UI-RaidTargetingIcon_5]]},
        {'Square',[[Interface\TargetingFrame\UI-RaidTargetingIcon_6]]},
        {'Cross',[[Interface\TargetingFrame\UI-RaidTargetingIcon_7]]},
        {'Skull',[[Interface\TargetingFrame\UI-RaidTargetingIcon_8]]},
    },
    
    classRangeChecks = {  --{CLASS = hostileSpellName,}
        WARLOCK = 'Shadow Bolt',
        DRUID = 'Moonfire',
        PRIEST = 'Mind Blast',
        DEATHKNIGHT = 'Death Grip',
        WARRIOR = 'Shoot',
        ROGUE = 'Shoot',
        PALADIN = 'Judgement',
        MAGE = 'Fireball',
        SHAMAN = 'Lightning Bolt',
        HUNTER = 'Arcane Shot',
    },

}

--[[
Database version migration logic.
]]--
migration = {
    [2] = function(config) 
            --Convert .headerWidth to .targetWidth
            if config.headerWidth then config.targetWidth = config.headerWidth/2 end
        end,
}

